<template>
<Page title='Sign up to a new account' link='/sign-in'>
                  <form novalidate="true" @submit.prevent="handleSignUp">
                    <div class="relative w-full mb-3">
                      <label
                        class="block uppercase text-gray-700 text-xs font-bold mb-2"
                        for="grid-password"
                        >Email</label
                      ><input
                        v-model="email"
                        type="email"
                        class="border-0 px-3 py-3 placeholder-gray-400 text-gray-700 bg-white rounded text-sm shadow focus:outline-none focus:ring w-full"
                        placeholder="Email"
                        style="transition: all 0.15s ease 0s;"
                        required
                      />
                    </div>
                    <div class="relative w-full mb-3">
                      <label
                        class="block uppercase text-gray-700 text-xs font-bold mb-2"
                        for="grid-password"
                        >Password</label
                      ><input
                        v-model="password"
                        type="password"
                        class="border-0 px-3 py-3 placeholder-gray-400 text-gray-700 bg-white rounded text-sm shadow focus:outline-none focus:ring w-full"
                        placeholder="Password"
                        style="transition: all 0.15s ease 0s;"
                        required
                      />
                    </div>
                    <div class="relative w-full mb-3">
                      <label
                        class="block uppercase text-gray-700 text-xs font-bold mb-2"
                        for="grid-password"
                        >Username</label
                      ><input
                        v-model="username"
                        type="text"
                        class="border-0 px-3 py-3 placeholder-gray-400 text-gray-700 bg-white rounded text-sm shadow focus:outline-none focus:ring w-full"
                        placeholder="Username"
                        style="transition: all 0.15s ease 0s;"
                        required
                      />
                    </div>
                    <div v-if="errors.length" class="bg-red-700 mt-6 rounded px-6 py-3 text-white">
                      <p >
    <b>Please, correct to continue:</b>
    <ul>
      <li v-for="error in errors" v-bind:key=error> - {{ error }}</li>
    </ul>
  </p>
  </div>
                    <div class="text-center mt-6 flex items-center justify-between">
                      <button
                        class="bg-white text-gray-700 active:bg-gray-700 text-sm font-bold uppercase px-6 py-3 rounded shadow hover:shadow-lg outline-none focus:outline-none mr-1 mb-1 w-full"
                        style="transition: all 0.15s ease 0s;"
                        @click="handleClear"
                      >
                        Clear
                      </button>
                        <button
                        class="bg-gray-900 text-white active:bg-gray-700 text-sm font-bold uppercase px-6 py-3 rounded shadow hover:shadow-lg outline-none focus:outline-none mr-1 mb-1 w-full"
                        type="submit"
                        style="transition: all 0.15s ease 0s;"
                      >
                        Sign Up
                      </button>
                    </div>

                  </form>
                <hr class="mt-6 border-b-1 border-gray-400" />
                <div class="text-gray-500 text-center mb-3 font-bold">
                    <small>Already a user? So <nuxt-link to="/sign-in">sign in now!</nuxt-link></small>
                  </div>
</Page>
</template>

<script>
export default {
  data() {
    return {
    email: '',
    password: '',
    username: '',
    errors: []
    }
  },
  methods: {
    async handleSignUp() {
      this.errors = []
      const regexEmail = /[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/;
      const regexPassword = /([A-zÁ-ú]|[0-9]){8,32}/
      const regexUsername = /^\d+$/

      if(!regexEmail.test(this.email)) this.errors.push('The email must be valid.')
      if(!regexPassword.test(this.password)) this.errors.push('The password must be at least 8-32 characters long.')
      if(regexUsername.test(this.username[0])) this.errors.push('The username cant begin with numbers.')
      if(!this.username) this.errors.push('The username is required.')

      if(this.errors.length === 0)
      try{
        await this.$axios.$post('http://localhost:8080/register', {
        email: this.email,
        password: this.password,
        username: this.username,
    }).then(response => {
        const id = JSON.parse(atob(response.accessToken.split('.')[1]));
        this.$store.commit('saveInfo', { email: this.email, id: id.sub, accessToken: response.accessToken });
        this.$router.push(`users/${id.sub}`);
    })
    } catch(e){
    this.errors.push(`${e.response.data}, please try again!`)
    }
    },
    handleClear() {
        this.email = "";
        this.password = "";
        this.username = "";
    }
  },

}
</script>